DECLARE SUB GetChanData (a%)
DECLARE SUB DICommand (comm$)
DECLARE SUB SelectCommPort (port$)      'port$ = comm port number



' Global and constant data
DIM SHARED ChanData%(2)         '
CONST TRUE = -1
CONST FALSE = 0


ON ERROR GOTO ErrorHandler


CLS

CALL SelectCommPort("1")   'Select comm port 1

CALL DICommand("C2")       'Select two channels

CALL DICommand("S1")       'Start acq


a% = 0
LOCATE 3, 1
DO WHILE INKEY$ = ""
  
   CALL GetChanData(a%)
   LOCATE 5, 1
   PRINT "Chn1 = "; ChanData%(1), "Chn2 = "; ChanData%(2)

LOOP

CALL DICommand("S0")       'Stop acq

CLOSE #1

END

ErrorHandler:
PRINT "IO error"
   END

'       Send command to DI100 series at #1
SUB DICommand (comm$)
   a$ = CHR$(0) + comm$            'Send null then ASCII command
   PRINT #1, a$;
   DO WHILE INPUT$(1, #1) <> LEFT$(comm$, 1)  'Wait for command response
   LOOP
   a$ = INPUT$(1, #1)           'Get command data
END SUB

SUB GetChanData (a%)

   Byte% = ASC(INPUT$(1, #1))           'get sync bit
   DO WHILE ((Byte% AND 1) = 1)
        Byte% = ASC(INPUT$(1, #1))
   LOOP

   ChanData%(1) = ((BYTE0% AND &HF8) / 8) + ((ASC(INPUT$(1, #1)) AND &HFE) / 2) * 32
  
   Byte% = ASC(INPUT$(1, #1))
   ChanData%(2) = ((Byte% AND &HF8) / 8) + ((ASC(INPUT$(1, #1)) AND &HFE) / 2) * 32

END SUB

SUB SelectCommPort (port$)
   OPEN "COM" + port$ + ":4800,N,8,1,BIN,CD0,CS0,DS0,TB2048,RB2048" FOR RANDOM AS #1

'       Wait .1 seconds for DI-150 to initialize  '
  
   start! = TIMER
   WHILE (TIMER - start!) < .05
   WEND
'   CLOSE #1
'       Wait .1 seconds for DI-150 to initialize  '
'   start! = TIMER
'   WHILE (TIMER - start!) < .05
'   WEND
  
'   OPEN "COM" + port$ + ":2400,N,8,1,BIN,CD0,CS0,DS0,TB2048,RB2048" FOR RANDOM AS #1
'
'       Wait .1  seconds for DI-150 to initialize  '
'   start! = TIMER
'   WHILE (TIMER - start!) < .1
'   WEND



'     Clear any spurious readings from buffer
   a$ = INPUT$(LOC(1), #1)

END SUB

